//
//  ExampleController.m
//  GLSLBindingSample
//
//  Created by Jens Ayton on 2007-07-29.
//  Copyright 2007 Jens Ayton. All rights reserved.
//

#import "ExampleController.h"
#import "ExampleOpenGLView.h"
#import "ExampleModel.h"


@implementation ExampleController

- (id)init
{
	self = [super init];
	if (self != nil)
	{
		_model = [[ExampleModel alloc] init];
	}
	return self;
}


- (void)dealloc
{
	[window release];
	[_model release];
	[_timer invalidate];
	
	[super dealloc];
}


- (void)awakeFromNib
{
	NSRunLoop				*runLoop = nil;
	
	[colorWell setColor:[_model color]];
	[shininessSlider setDoubleValue:[_model shininess]];
	[glView setModel:_model];
	
	_startTime = [[NSDate date] retain];
	_timer = [NSTimer timerWithTimeInterval:0.05
									 target:self
								   selector:@selector(update)
								   userInfo:nil
									repeats:YES];
	runLoop = [NSRunLoop currentRunLoop];
	[runLoop addTimer:_timer forMode:NSDefaultRunLoopMode];
	[runLoop addTimer:_timer forMode:NSEventTrackingRunLoopMode];
}


- (IBAction)takeShininessFrom:(id)sender
{
	[_model setShininess:[sender doubleValue]];
}


- (IBAction)takeColorFrom:(id)sender
{
	[_model setColor:[sender color]];
}


- (void)update
{
	double timeOffset = [_startTime timeIntervalSinceNow];
	
	[glView setMainLightAngle:timeOffset * 30.0];
	[glView setSecondaryLightAngle:timeOffset * -11.0 - 60];
}

@end
