//
//  ExampleModel.m
//  GLSLBindingSample
//
//  Created by Jens Ayton on 2007-07-29.
//  Copyright 2007 Jens Ayton. All rights reserved.
//

#import "ExampleModel.h"


@implementation ExampleModel

- (id)init
{
	self = [super init];
	if (self != nil)
	{
		_shininess = 2.0f;
		_color = [[NSColor lightGrayColor] retain];
	}
	return self;
}


- (void)dealloc
{
	[_color release];
	
	[super dealloc];
}


- (float)shininess
{
	return _shininess;
}


- (void)setShininess:(float)shininess
{
	if (shininess < 0.0f) shininess = 0.0f;
	if (10.0 < shininess) shininess = 10.0;
	_shininess = shininess;
}

- (NSColor *)color
{
	return _color;
}


- (void)setColor:(NSColor *)color
{
	if (color != nil)
	{
		[_color autorelease];
		_color = [color retain];
	}
}

@end
